<!DOCTYPE html>
<html>
  <head>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/2.3.0/socket.io.js"></script>
    <meta name="viewport" content="width=device-width, initial-scale=1">
  </head>
  <body>
    <div class="container">

      <input type="hidden" name="userId" id="userId" > 

      <label for="email"><b>Email</b></label>
      <input type="text" placeholder="Enter Email" name="email" id="email" required>

      <label for="pName"><b>Profile Name</b></label>
      <input type="text" placeholder="Enter Profile name" name="pName" id="pName" required>

      <label for="name"><b>Name</b></label>
      <input type="text" placeholder="Entername" name="name" id="name" required>

      <label for="age"><b>Age</b></label>
      <input type="text" placeholder="Enter Profile age" name="age" id="age" required>
      <hr>

      <button type="submit" id="submit" class="registerbtn">Save</button>
      <button type="button" id="cancelBtn" onclick="cancelUser()">Cancel</button>
    </div>
    <div>
      <table>
        <thead>
          <tr>
            <th>id</th>
            <th>name</th>
            <th>Profile name</th>
            <th>Email</th>
            <th>Age</th>
            <th>Action</th>
          </tr>
        </thead>
        <tbody id="userList">
          
        </tbody>
      </table>
    </div>
</body>

<script>
  const socket = io('localhost:3002');

$(document).ready(function(){

  socket.emit("listUsers")

  socket.on('editUser', (user)=>{
    $('#email').val(user.email);
    $('#pName').val(user.profileName);
    $('#name').val(user.name);
    $('#age').val(user.age);
    $('#userId').val(user._id);
  })

  socket.on('alert',(alertObj)=>{
      switch(alertObj.status) {
        case 'create' :
            alert(" user create " + alertObj.message)
          break;
        case 'delete' :
            alert(" user delete " + alertObj.message)
          break;
         case 'edit' :
            alert(" user edit " + alertObj.message)
          break;
      }
      cancelUser();
      socket.emit("listUsers")
  })

    socket.on('userData', (data)=>{
      $("#userList tr").remove(); 
      if(data.length) {
        let $tbody ='';
        for(let i=0;i<data.length;i++){
          $tbody  = $tbody +`<tr>
              <td> ${i+1}</td>
              <td> ${data[i].name}</td>
              <td> ${data[i].profileName}</td>
              <td> ${data[i].email}</td>
              <td> ${data[i].age}</td>
              <td><a href="javascript:void(0)" id=${data[i]._id} onclick="editUser(this)">Edit</a></td>
              <td><a href="javascript:void(0)" id=${data[i]._id} onclick=deleteUser(this)>Delete</a></td>
            </tr>`; 
        }
        $('#userList').append($tbody);
      }
    })

    $("#submit").click(function(){
      const user = {
        email : $('#email').val(),
        profileName : $('#pName').val(),
        name : $('#name').val(),
        age : $('#age').val(),
     }
      if($("#submit").html() === "Save"){
        socket.emit('createUser', user);
      }else{
        const id = $('#userId').val();
        socket.emit('editUser', {id ,user});
      }
    })

   function cancelUser(){
      $('#email').val('');
      $('#pName').val('');
      $('#name').val('');
      $('#age').val('');
      $('#userId').val('');
      $('#submit').html('Save');
    }

  });

function editUser(elm) {
  $('#submit').html('Update');
  socket.emit('getUserData' , elm.id);
}

function deleteUser(elm){
  socket.emit('deleteUser', elm.id);
}


</script>
</html>